<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>CarbonPHP Security</h1>

		<p>This page outlines some of the best practices for web-application security, and how CarbonPHP incorporates
		some of these security features.</p>
	</div>

	<div class="content">
		<h1>URI Security</h1>

		<p>CarbonPHP restricts which characters that can be placed in the URI in order to minimise the possibility
		of malicious data being passed to the web-application.</p>

		<p>URIs can only contain the following non-alpha numeric characters.</p>

		<ul>
			<li>Tilde: ~</li>
			<li>Period: .</li>
			<li>Colon: :</li>
			<li>Underscore: _</li>
			<li>Hyphen: -</li>
		</ul>
	</div>

	<div class="content">
		<h1>GET, POST, and COOKIE Arrays</h1>

		<p>GET data is disallowed by CarbonPHP since CarbonPHP utilises URI segments.  The <b>$_GET</b> array is simply
		<b>unset()</b> by the Input class during the initialisation of CarbonPHP.  The <b>$_POST</b> and
		<b>$_COOKIE</b> arrays are sanitised by the Input class.</p>
	</div>

	<div class="content">
		<h1>Register Globals</h1>

		<p>During the initialisation of CarbonPHP all global variables except <b>$_POST</b> and <b>$_COOKIE</b> are
		<b>unset()</b>.  The unsetting of these arrays is the same as turning <b>register_globals</b> off.</p>
	</div>

	<div class="content">
		<h1>Magic Quotes</h1>

		<p>The magic quotes directive is disabled during the initialisation of CarbonPHP so you don't have to remove
		slashes when retrieving data from your database.</p>
	</div>

	<div class="content">
		<h1>Best Security Practices</h1>

		<p>Before accepting any data into your web-application, this means <b>any</b> data.  You are encouraged to
		to practice the following three step approach.</p>

		<ol>
			<li>Filter all the data as if it were malicious.</li>
			<li>Validate the data to ensure it meets to the correct type, length, etc.</li>
			<li>Escape the data before submitting it into your database to stop SQL injection.</li>
		</ol>
	</div>

	<div class="content">
		<h1>Cross Site Scripting Filtering</h1>

		<p>CarbonPHP features a cross site scripting filter.  This filter looks for common techniques used to embed
		malicious javascript into your data, or other types of code.</p>
	</div>

	<div class="content">
		<h1>SQL Injection Filtering</h1>

		<p>You should never insert data into your database without escaping it.  carbonPHPs database class automatically
		escapes data that is being inserted into the database.</p>
	</div>
</body>

</html>
